program GrRes;

uses
  Windows,
  Graphics,
  SysUtils,
  Types;

{$R *.res}

type
 TResult=record
   Result:Boolean;
   q     :Single
  end;

 TResults=array[1..5000] of TResult;


var
 F:File of TResult;
 Results:TResults;
 Canvas:TCanvas;
 ScreenDC:HDC;
 aRect:TRect;
 i,n0:Integer;

begin
 {Initialising the canvas}
 ScreenDC:=GetDC(0);
 Canvas:=TCanvas.Create;
 Canvas.Handle:=ScreenDC;
 {Reading the external data}
 AssignFile(F,'Results.dat');
 Reset(F);
 n0:=1;
 While not EOF(F) do
 begin
  Read(F,Results[n0]);
  Inc(n0);
 end;
 CloseFile(F);
 Dec(n0);
 {Drawing the graph}
 {Clearing the area}
 aRect:=Rect(0,0,800,600);
 Canvas.Brush.Color:=clWhite;
 Canvas.FillRect(aRect);
 {Preparing the scale}
 Canvas.MoveTo(0,300);
 Canvas.LineTo(800,300);
 for i:=0 to 9 do
  Canvas.TextOut(80*i,320,FloatToStr(i/10));
 {Illustrating the data}
 for i:=1 to n0 do
 begin
  if Results[i].Result then
  begin
   Canvas.Pen.Color:=clRed;
   Canvas.MoveTo(Round(800*Results[i].q),300);
   Canvas.LineTo(Round(800*Results[i].q),200)
  end
  else
  begin
   Canvas.Pen.Color:=clBlue;
   Canvas.MoveTo(Round(800*Results[i].q),300);
   Canvas.LineTo(Round(800*Results[i].q),400)
  end
 end;
 {Waititng}
 for i:=1 to 1333000000 do
  n0:=n0;
 {Releasing the canvas}
 ReleaseDC(0,ScreenDC);
 Canvas.Free;
end.
