program iResults;

{$APPTYPE CONSOLE}

uses
  SysUtils;


type
 TResult=record
   Result:Boolean;
   q     :Single
  end;

 TResults=array[1..5000] of TResult;

var
 F:File of TResult;
 Results:TResults;
 i,j,n0,sn:LongInt;
 q,q0,q1,q2:Single;
 sn1:Single;

function R(const Res:Boolean; const qi,q0:Single):Single;
begin
 R:=0;
 if ((qi>q0) and Res) then
  R:=1;
 if ((qi<q0) and not Res) then
  R:=1;
end;

begin
 AssignFile(F,'Results.dat');
 Reset(F);
 n0:=1;
 While not EOF(F) do
 begin
  Read(F,Results[n0]);
  Inc(n0);
 end;
 CloseFile(F);
 Dec(n0);
 {Evaluating the result}
 {The first...}
 q1:=0; sn:=0;
 for i:=1 to n0 do
  if Results[i].Result then
   q1:=q1 + Results[i].q;
 for i:=1 to n0 do
  if Results[i].Result then
   Inc(sn);
 q1:=q1/sn;
 {...and the second.}
 q2:=0; sn:=0;
 for i:=1 to n0 do
  if not Results[i].Result then
   q2:=q2 + Results[i].q;
 for i:=1 to n0 do
  if not Results[i].Result then
   Inc(sn);
 q2:=q2/sn;
 Writeln('Total ',n0,' experiments');
 Writeln('q1: ',q1);
 Writeln('q2: ',q2);
 Writeln('Average q ',(q1+q2)/2);
 Writeln('Advanced average q evaluation');
 q0:=0.5;
 for j:=1 to 500 do
 begin
  q1:=0; sn1:=0;
  for i:=1 to n0 do
   q1:=q1 + Results[i].q*R(Results[i].Result,Results[i].q,q0);
  for i:=1 to n0 do
   sn1:=sn1 + R(Results[i].Result,Results[i].q,q0);
  if sn1=0 then
  begin
   Writeln('Division by zero on ',j,'-s step');
   Writeln('q1 is', q1);
   Writeln('q0 is', q0);
   Break;
  end;
  q0:=q1/sn1;
 end;
 Writeln('Advanced result is ',q0);
 Readln;
end.
